#!/bin/bash
set -eu
pan_session() {
    sid="$1"
    typeset -a clients
    typeset -a heights
    height=0
    width=9999
    while read tty w h; do
	clients+=("$tty")
	height=$((height + h))
	heights+=("$height")
	if [[ "$w" -lt "$width" ]]; then
	    width="$w"
	fi
    done < <(tmux list-clients -F '#{client_tty} #{client_width} #{client_height}' -t "$sid")
    no_clients=${#clients[@]}
    if [[ "$no_clients" -gt 0 ]]; then
	tmux resize-window -t "$sid:" -x "$width" -y "$height"

	if [[ "$no_clients" -gt 1 ]]; then
	    tmux refresh-client -t "${clients[0]}" -U "$height"
	else
	    tmux refresh-client -t "${clients[0]}" -c
	fi

	for ((i=1; i < no_clients; i++)); do
	    tmux refresh-client -t "${clients[$i]}" -U "$height" \; \
		 refresh-client -t "${clients[$i]}" -D ${heights[$((i-1))]}
	done
    fi
}

while read sid; do
    pan_session "$sid"
done < <(tmux list-sessions -F '#{session_id}')
